p <- 1:11
q <- order(p, decreasing=T)
q <- 11:1
mat.perm(n1,q)

u <- vec.unit(11)
d <- n1 %*% u + t(u %*% n1 )
q <- sort(d,index=T)$ix
n2 <- mat.perm(n1,q)
d2 <- n2 %*% u + t(u %*% n2 )
d2

vec.sel(11,c(3,7))
vec.sel(11,5)

mat.power(n1,3)

# Structural models, p. 146

r1 <- n1 + diag(10)
r2 <- mat.bin(mat.power(r1,2))
r3 <- mat.bin(mat.power(r1,3))
r4 <- mat.bin(mat.power(r1,4))
r <- mat.close.bin(n1) + diag(10)

# Structural models, p. 151

s1 <- n2 + t(n2) + diag(10)
s2 <- mat.bin(mat.power(s1,2))
s2
# iz s2 preberemo permutacijo
wc <- mat.perm(n2,c(1,4,5,10,2,6,9,3,7,8))

mat.perm(mat.dist(n2),c(1,4,2,6,3,7,8,5,9,10))

# kombinatorna teorija matrica, p. 189

r <- mat.close.bin(n3)
r
rp <- mat.perm(r,c(13,14,12,4,5,6,8,9,10,11,1,2,3,7))
rp
np <- mat.perm(n3,c(13,14,12,4,5,6,8,9,10,11,1,2,3,7))
np

x0 <- vec.sel(14,13)
x1 <- x0 %*% n3
x1
x2 <- x1 %*% n3
x2
x3 <- x2 %*% n3
x3
x4 <- x3 %*% n3
x4
x5 <- x4 %*% n3
x5
drop(mat.bin(x5))

p <- mat.paths(n3)
vec.path(p$tra,13,11)

mat.prob(n2)
mat.prob(n3)

# Roy-Warshall (pascal)
# for j := 1 to n  do for i := 1 to  n do
#   if j in  r[i] then  r[i] : = r[i] + r[j]


c <- vec.sel(10,2)
s <- c
for (i in 1:10) { s <- s %*% n1; cat(i," ",s,"\n") }

s <- c
for (i in 1:10) { s <- mat.bin(s %*% n1); cat(i," ",s,"\n") }


p <- c(1,11,13,17,18,2,4,14,19,3,5,7,9,15,20,6,8,10,12,16)
length(p)
mat.perm(n7,p)
a <- mat.perm(n7,p)
mat.bin(mat.power(a,4))
mat.bin(mat.power(a,8))


r <- n11
q <- mat.bin(r %*% t(r))
q

s1 <- mat.bin(q %*% r)
s1

s2 <- mat.bin(q %*% s1)
s2


#----------------------------------------------------
# Markov Chains


# pasture
# F.S. Roberts: Discrete mathematical models, p.266
P <- c(  3/5 , 3/10,  0 , 1/10,
         1/10, 2/5 , 1/2,  0  ,
         3/4 ,  0  , 1/5, 1/20,
          0  ,  0  ,  0 ,  1   )
n <- c('soil','grass','cattle','outside')
P <- matrix(nrow=4,byrow=T,dimnames=list(n,n),data=P)

# summer weather
# F.S. Roberts: Discrete mathematical models, p.267
S <- c( 1/3, 1/2, 1/6,
        1/2, 1/3, 1/6,
        1/3, 1/3, 1/3 )
n <- c('hot','moderate','cool')
S <- matrix(nrow=3,byrow=T,dimnames=list(n,n),data=S)



# fixed point of stable chain
n <- nrow(S)
A <- t(S)-diag(n); A[n,] <- rep(1,n)
b <- rep(0,n); b[n] <- 1
w <- solve(A,b)
W <- matrix(nrow=n,ncol=n,byrow=T,w,dimnames=dimnames(S))
Z <- solve(diag(n) - (S - W))
E <- (diag(n) - Z + matrix(nrow=n,ncol=n,byrow=T,diag(Z))) %*% diag(1/w)
dimnames(E) <- dimnames(S)


max(abs(S %*% W - W %*% S))
max(abs(S %*% W - W))



# gambler's ruin
# F.S. Roberts: Discrete mathematical models, p.268
p <- 1/3
G <- c( 1 , 0 , 0 , 0, 0,
       1-p, 0 , p , 0, 0,
        0 ,1-p, 0 , p, 0,
        0 , 0 ,1-p, 0, p,
        0 , 0 , 0 , 0, 1 )
n <- c('$0','$1','$2','$3','$4')
G <- matrix(nrow=5,byrow=T,dimnames=list(n,n),data=G)

n <- 5; m <- 2
G <- mat.perm(G,c(1,5,2,3,4))
Q <- G[(m+1):n,(m+1):n]
N <- solve(diag(n-m)-Q)
R <- G[(m+1):n,1:m]
B <- N %*% R


# betweeness

g <- c(
 0, 1, 1, 0, 0, 0, 0, 0,
 0, 0, 0, 1, 1, 0, 0, 0,
 0, 0, 0, 1, 1, 0, 0, 0,
 0, 0, 0, 0, 0, 1, 1, 0,
 0, 0, 0, 0, 1, 1, 1, 0,
 0, 0, 0, 0, 0, 0, 0, 1,
 0, 0, 0, 0, 0, 0, 0, 1,
 0, 1, 0, 0, 0, 0, 0, 0  )
n <- 1:8
g <- matrix(nrow=8,byrow=T,dimnames=list(n,n),data=g)

mat.geodesics(g)










